'use strict';

var MicroEvent = require('microevent');

function OnedrivePicker(button, sio, options) {
	var that = this;
  var currentPath = window.location.protocol + '//' + window.location.hostname;

	function handlePick(data) {
		var file = data.value[0];
		var ext = file.name.split('.').pop().toLowerCase();
		if($.inArray(ext, options.extensions) != -1){
			that.trigger('picked', file);
		} else {
			window.alert('Selected document is not a valid video file');
			that.trigger('done', 1);
		}
	}

	function handleNoPick() {
		that.trigger('done', 1);
	}

	button.on('click', function(){
		button.blur();
		that.trigger('open');
    OneDrive.open({
			clientId: options.clientId,
			action: 'download',
			advanced: {
				redirectUri: currentPath + '/onedrive/picker'
			},
			success: handlePick,
			cancel: handleNoPick,
			error: handleNoPick
    });
	});

	this.cancel = function() {
		sio.emit('cancel-onedrive');
	}

  sio.on('update-onedrive', function(status) {
  	that.trigger('update', status);
  });

  sio.on('ready-onedrive', function(code, info) {
  	that.trigger('done', code, info);
  });
}

MicroEvent.mixin(OnedrivePicker);

module.exports = OnedrivePicker;
